<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (45)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="object.keys-values-entries">Object.keys, values, entries</h1>
    <p>
      Let’s step away from the individual data structures and talk about the
      iterations over them.
    </p>
    <p>
      In the previous chapter we saw methods <code>map.keys()</code>,
      <code>map.values()</code>, <code>map.entries()</code>.
    </p>
    <p>
      These methods are generic, there is a common agreement to use them for
      data structures. If we ever create a data structure of our own, we should
      implement them too.
    </p>
    <p>They are supported for:</p>
    <ul>
      <li><code>Map</code></li>
      <li><code>Set</code></li>
      <li><code>Array</code></li>
    </ul>
    <p>
      Plain objects also support similar methods, but the syntax is a bit
      different.
    </p>
    <h2 id="object.keys-values-entries-1">Object.keys, values, entries</h2>
    <p>For plain objects, the following methods are available:</p>
    <ul>
      <li>
        <a href="mdn:js/Object/keys">Object.keys(obj)</a> – returns an array of
        keys.
      </li>
      <li>
        <a href="mdn:js/Object/values">Object.values(obj)</a> – returns an array
        of values.
      </li>
      <li>
        <a href="mdn:js/Object/entries">Object.entries(obj)</a> – returns an
        array of <code>[key, value]</code> pairs.
      </li>
    </ul>
    <p>Please note the distinctions (compared to map for example):</p>
    <table>
      <thead>
        <tr class="header">
          <th></th>
          <th>Map</th>
          <th>Object</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>Call syntax</td>
          <td><code>map.keys()</code></td>
          <td>
            <code>Object.keys(obj)</code>, but not <code>obj.keys()</code>
          </td>
        </tr>
        <tr class="even">
          <td>Returns</td>
          <td>iterable</td>
          <td>“real” Array</td>
        </tr>
      </tbody>
    </table>
    <p>
      The first difference is that we have to call
      <code>Object.keys(obj)</code>, and not <code>obj.keys()</code>.
    </p>
    <p>
      Why so? The main reason is flexibility. Remember, objects are a base of
      all complex structures in JavaScript. So we may have an object of our own
      like <code>data</code> that implements its own
      <code>data.values()</code> method. And we still can call
      <code>Object.values(data)</code> on it.
    </p>
    <p>
      The second difference is that <code>Object.*</code> methods return “real”
      array objects, not just an iterable. That’s mainly for historical reasons.
    </p>
    <p>For instance:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="dt">age</span><span class="op">:</span> <span class="dv">30</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="op">};</span></a></code></pre>
    </div>
    <ul>
      <li><code>Object.keys(user) = ["name", "age"]</code></li>
      <li><code>Object.values(user) = ["John", 30]</code></li>
      <li>
        <code>Object.entries(user) = [ ["name","John"], ["age",30] ]</code>
      </li>
    </ul>
    <p>
      Here’s an example of using <code>Object.values</code> to loop over
      property values:
    </p>
    <p>```js run let user = { name: “John”, age: 30, };</p>
    <p>
      // loop over values for (let value of Object.values(user)) { alert(value);
      // John, then 30 } ```
    </p>
    <p>
      ``<code
        >warn header="Object.keys/values/entries ignore symbolic properties"
        Just like a</code
      >for..in<code>loop, these methods ignore properties that use</code
      >Symbol(…)` as keys.
    </p>
    <p>
      Usually that’s convenient. But if we want symbolic keys too, then there’s
      a separate method
      <a href="mdn:js/Object/getOwnPropertySymbols"
        >Object.getOwnPropertySymbols</a
      >
      that returns an array of only symbolic keys. Also, there exist a method
      <a href="mdn:js/Reflect/ownKeys">Reflect.ownKeys(obj)</a> that returns
      <em>all</em> keys. ```
    </p>
    <h2 id="transforming-objects">Transforming objects</h2>
    <p>
      Objects lack many methods that exist for arrays, e.g. <code>map</code>,
      <code>filter</code> and others.
    </p>
    <p>
      If we’d like to apply them, then we can use
      <code>Object.entries</code> followed by <code>Object.fromEntries</code>:
    </p>
    <ol type="1">
      <li>
        Use <code>Object.entries(obj)</code> to get an array of key/value pairs
        from <code>obj</code>.
      </li>
      <li>Use array methods on that array, e.g. <code>map</code>.</li>
      <li>
        Use <code>Object.fromEntries(array)</code> on the resulting array to
        turn it back into an object.
      </li>
    </ol>
    <p>
      For example, we have an object with prices, and would like to double them:
    </p>
    <p>```js run let prices = { banana: 1, orange: 2, meat: 4, };</p>
    <p>
      <em>!</em> let doublePrices = Object.fromEntries( // convert to array,
      map, and then fromEntries gives back the object
      Object.entries(prices).map(([key, value]) =&gt; [key, value * 2]) );
      <em>/!</em>
    </p>
    <p>alert(doublePrices.meat); // 8 ```</p>
    <p>
      It may look difficult at first sight, but becomes easy to understand after
      you use it once or twice. We can make powerful chains of transforms this
      way.
    </p>
  </body>
</html>
